Bug 1643266 (python-libNeuroML) - Review Request: python-libNeuroML - Python libNeuroML for working with neuronal models specified in NeuroML
Summary: Review Request: python-libNeuroML - Python libNeuroML for working with neuron...
Status: CLOSED ERRATA
Alias: python-libNeuroML
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Miro Hrončok
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Keywords:
Depends On:
Blocks: fedora-neuro
TreeView+ depends on / blocked
 
Reported: 2018-10-25 19:06 UTC by Ankur Sinha (FranciscoD)
Modified: 2018-11-10 03:17 UTC (History)
3 users (show)

(edit)
Clone Of:
(edit)
Last Closed: 2018-11-07 02:04:37 UTC
mhroncok: fedora-review+


Attachments (Terms of Use)

Description Ankur Sinha (FranciscoD) 2018-10-25 19:06:50 UTC
Spec URL: https://ankursinha.fedorapeople.org/python-libNeuroML/python-libNeuroML.spec
SRPM URL: https://ankursinha.fedorapeople.org/python-libNeuroML/python-libNeuroML-0.2.45-1.fc29.src.rpm

Description:
This package provides Python libNeuroML, for working with neuronal models specified in NeuroML 2 (http://neuroml.org/neuromlv2).  NeuroML provides an object model for describing neuronal morphologies, ion channels, synapses and 3D network structure.  Documentation is available at http://readthedocs.org/docs/libneuroml/en/latest/

Fedora Account System Username: ankursinha

Koji scratch build for rawhide:
https://koji.fedoraproject.org/koji/taskinfo?taskID=30461768

Koji scratch build for f29 with Python 2 enabled: 
https://koji.fedoraproject.org/koji/taskinfo?taskID=30461733

Comment 2 Miro Hrončok 2018-10-25 19:23:29 UTC
I will review this.

Comment 3 Miro Hrončok 2018-10-25 19:26:04 UTC
Tip: If you use %bcond_with python2 and %if %{with python2}, the conditional is more easily tested, as it can be mockbuild --with python2.

The spec looks reasonable, will run some checks.

Comment 4 Miro Hrončok 2018-10-25 19:34:25 UTC
+ make html
sphinx-build -b html -d _build/doctrees   . _build/html
BUILDSTDERR: make: sphinx-build: Command not found
BUILDSTDERR: make: *** [Makefile:45: html] Error 127


This doesn't work in mock, but it works in Koji. Set SPHINXBUILD=sphinx-build-3 to make it buildable.

Comment 5 Ankur Sinha (FranciscoD) 2018-10-25 19:52:39 UTC
(In reply to Miro Hrončok from comment #3)
> Tip: If you use %bcond_with python2 and %if %{with python2}, the conditional
> is more easily tested, as it can be mockbuild --with python2.

That's neat! I wasn't aware of bcond. 

Are these only to be used for testing, though, or can one use them in the scm with koji too? I.e., will koji add --with python2 when building for F28/F29, or do I still have to flip the conditional for these branches?

Thanks for taking this one up,
Ankur

Comment 6 Miro Hrončok 2018-10-25 21:10:50 UTC
(In reply to Ankur Sinha (FranciscoD) from comment #5)
> Are these only to be used for testing

Yes.

> will koji add --with python2 when building for
> F28/F29

No.

> do I still have to flip the conditional for these branches?

Yes.

Comment 7 Miro Hrončok 2018-10-26 06:14:32 UTC
(In reply to Miro Hrončok from comment #4)
> + make html
> sphinx-build -b html -d _build/doctrees   . _build/html
> BUILDSTDERR: make: sphinx-build: Command not found
> BUILDSTDERR: make: *** [Makefile:45: html] Error 127
> 
> 
> This doesn't work in mock, but it works in Koji. Set
> SPHINXBUILD=sphinx-build-3 to make it buildable.

I cannot run the checks if I cannot build the package in mock. So This is what I'm waiting for now.

Comment 8 Ankur Sinha (FranciscoD) 2018-10-26 07:58:02 UTC
Updated spec/srpm:

https://ankursinha.fedorapeople.org/python-libNeuroML/python-libNeuroML.spec

https://ankursinha.fedorapeople.org/python-libNeuroML/python-libNeuroML-0.2.45-2.fc29.src.rpm

Rawhide scratch build:
https://koji.fedoraproject.org/koji/taskinfo?taskID=30470273

(I've used bcond temporarily for your convenience. I'll remove it before pushing to SCM.)

Comment 10 Miro Hrončok 2018-10-26 11:42:47 UTC
(In reply to Ankur Sinha (FranciscoD) from comment #8)
> (I've used bcond temporarily for your convenience. I'll remove it before
> pushing to SCM.)

The suggestion was for you. If you don't want it, don't put it there just for me ;)


Package Review
==============

Issues:

 * I believe the license should be BSD, not MIT.
 * There are stray unneeded shebangs, remove them (see rpmlint output).
 * Other rpmlint warnings (wrong-file-end-of-line-encoding, hidden-file-or-dir)

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated


===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[!]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "BSD 2-clause "Simplified" License", "Unknown or generated",
     "*No copyright* BSD (unspecified)"...
[x]: License file installed when any subpackage combination is installed.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package must not depend on deprecated() packages.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Python eggs must not download any dependencies during the build
     process.
[x]: A package which is used by another package via an egg interface should
     provide egg info.
[x]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Packages MUST NOT have dependencies (either build-time or runtime) on
     packages named with the unversioned python- prefix unless no properly
     versioned package exists. Dependencies on Python packages instead MUST
     use names beginning with python2- or python3- as appropriate.
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[-]: Uses parallel make %{?_smp_mflags} macro.
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[-]: Fully versioned dependency in subpackages if applicable.
[?]: Package functions as described.
[?]: Latest version is packaged.
[-]: Package does not include license text files separate from upstream.
[x]: Patches link to upstream bugs/comments/lists or are otherwise
     justified.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[?]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[?]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: python3-libNeuroML-0.2.45-3.fc30.noarch.rpm
          python-libNeuroML-doc-0.2.45-3.fc30.noarch.rpm
          python-libNeuroML-0.2.45-3.fc30.src.rpm
python3-libNeuroML.noarch: W: spelling-error %description -l en_US morphologies -> morphological, morphology
python3-libNeuroML.noarch: E: wrong-script-interpreter /usr/lib/python3.7/site-packages/neuroml/nml/nml.py /usr/bin/env python
python3-libNeuroML.noarch: E: non-executable-script /usr/lib/python3.7/site-packages/neuroml/nml/nml.py 644 /usr/bin/env python
python-libNeuroML-doc.noarch: W: spelling-error %description -l en_US morphologies -> morphological, morphology
python-libNeuroML-doc.noarch: W: wrong-file-end-of-line-encoding /usr/share/doc/python-libNeuroML-doc/examples/test_files/tmp2.swc
python-libNeuroML-doc.noarch: W: hidden-file-or-dir /usr/share/doc/python-libNeuroML-doc/html/.buildinfo
python-libNeuroML.src: W: spelling-error %description -l en_US morphologies -> morphological, morphology
python-libNeuroML.src:3: W: macro-in-comment %global
python-libNeuroML.src: E: specfile-error warning: Macro expanded in comment on line 3: %global with_py2 0
python-libNeuroML.src: E: specfile-error 
python-libNeuroML.src: E: specfile-error warning: Macro expanded in comment on line 3: %global with_py2 0
3 packages and 0 specfiles checked; 5 errors, 6 warnings.


Rpmlint (installed packages)
----------------------------
sh: /usr/bin/python: No such file or directory
python3-libNeuroML.noarch: W: spelling-error %description -l en_US morphologies -> morphological, morphology
python3-libNeuroML.noarch: W: invalid-url URL: https://pypi.python.org/pypi/libNeuroML <urlopen error [Errno -2] Name or service not known>
python3-libNeuroML.noarch: E: wrong-script-interpreter /usr/lib/python3.7/site-packages/neuroml/nml/nml.py /usr/bin/env python
python3-libNeuroML.noarch: E: non-executable-script /usr/lib/python3.7/site-packages/neuroml/nml/nml.py 644 /usr/bin/env python
python-libNeuroML-doc.noarch: W: spelling-error %description -l en_US morphologies -> morphological, morphology
python-libNeuroML-doc.noarch: W: invalid-url URL: https://pypi.python.org/pypi/libNeuroML <urlopen error [Errno -2] Name or service not known>
python-libNeuroML-doc.noarch: W: wrong-file-end-of-line-encoding /usr/share/doc/python-libNeuroML-doc/examples/test_files/tmp2.swc
python-libNeuroML-doc.noarch: W: hidden-file-or-dir /usr/share/doc/python-libNeuroML-doc/html/.buildinfo
2 packages and 0 specfiles checked; 2 errors, 6 warnings.



Requires
--------
python3-libNeuroML (rpmlib, GLIBC filtered):
    python(abi)
    python3dist(lxml)

python-libNeuroML-doc (rpmlib, GLIBC filtered):



Provides
--------
python3-libNeuroML:
    python3-libNeuroML
    python3.7dist(libneuroml)
    python3dist(libneuroml)

python-libNeuroML-doc:
    python-libNeuroML-doc



Source checksums
----------------
https://files.pythonhosted.org/packages/source/l/libNeuroML/libNeuroML-0.2.45.tar.gz :
  CHECKSUM(SHA256) this package     : ae708aee892c0e740606d9787d5570fc1dc34d6000c8cc4432ed25e48a38ff49
  CHECKSUM(SHA256) upstream package : ae708aee892c0e740606d9787d5570fc1dc34d6000c8cc4432ed25e48a38ff49

Comment 11 Ankur Sinha (FranciscoD) 2018-10-26 12:26:02 UTC
Thanks for the review.

(In reply to Miro Hrončok from comment #10)
> (In reply to Ankur Sinha (FranciscoD) from comment #8)
> > (I've used bcond temporarily for your convenience. I'll remove it before
> > pushing to SCM.)
> 
> The suggestion was for you. If you don't want it, don't put it there just
> for me ;)

Oh, I'm one of those people that abuse koji for this. I rarely run a local mock build on my system here. :)

> 
> Package Review
> ==============
> 
> Issues:
> 
>  * I believe the license should be BSD, not MIT.

Yes, corrected.

>  * There are stray unneeded shebangs, remove them (see rpmlint output).

Corrected too (and queried upstream: https://github.com/NeuralEnsemble/libNeuroML/issues/77)

>  * Other rpmlint warnings (wrong-file-end-of-line-encoding,
> hidden-file-or-dir)
> 

Corrected.

While I was at it, I also added missing Requires to the spec after looking at
the source files. The source's requirements and setup.py files do not specify
the complete set.


Now rpmlint says:
$ ls
python3-libNeuroML-0.2.45-4.fc30.noarch.rpm  python-libNeuroML-0.2.45-4.fc30.src.rpm  python-libNeuroML-doc-0.2.45-4.fc30.noarch.rpm

$ rpmlint *rpm
python3-libNeuroML.noarch: W: spelling-error %description -l en_US morphologies -> morphological, morphology
python-libNeuroML.src: W: spelling-error %description -l en_US morphologies -> morphological, morphology
python-libNeuroML-doc.noarch: W: spelling-error %description -l en_US morphologies -> morphological, morphology
3 packages and 0 specfiles checked; 0 errors, 3 warnings.


Corrected requires are now:
== python3-libNeuroML-0.2.45-4.fc30.noarch.rpm ==
Provides:
python3-libNeuroML = 0.2.45-4.fc30
python3.7dist(libneuroml) = 0.2.45
python3dist(libneuroml) = 0.2.45

Requires:
python(abi) = 3.7
python3dist(jsonpickle)
python3dist(lxml)
python3dist(numpy)
python3dist(pymongo)
python3dist(tables)

== python-libNeuroML-0.2.45-4.fc30.src.rpm ==
Provides:

Requires:
python3-devel
python3dist(jsonpickle)
python3dist(lxml)
python3dist(nose)
python3dist(numpy)
python3dist(pymongo)
python3dist(sphinx)
python3dist(tables)

== python-libNeuroML-doc-0.2.45-4.fc30.noarch.rpm ==
Provides:
python-libNeuroML-doc = 0.2.45-4.fc30

Requires:


--


Updated spec/srpm:
https://ankursinha.fedorapeople.org/python-libNeuroML/python-libNeuroML.spec

https://ankursinha.fedorapeople.org/python-libNeuroML/python-libNeuroML-0.2.45-4.fc29.src.rpm

Scratch build for rawhide:
https://koji.fedoraproject.org/koji/taskinfo?taskID=30472859

Cheers,
Ankur

Comment 12 Miro Hrončok 2018-10-26 20:31:43 UTC
Approved.

Comment 13 Ankur Sinha (FranciscoD) 2018-10-27 09:25:18 UTC
Thanks very much!

Comment 14 Gwyn Ciesla 2018-10-27 13:18:37 UTC
(fedscm-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/python-libNeuroML

Comment 15 Fedora Update System 2018-10-27 14:28:30 UTC
python-libNeuroML-0.2.45-4.fc28 has been submitted as an update to Fedora 28. https://bodhi.fedoraproject.org/updates/FEDORA-2018-f4c25f1515

Comment 16 Fedora Update System 2018-10-27 14:29:01 UTC
python-libNeuroML-0.2.45-4.fc29 has been submitted as an update to Fedora 29. https://bodhi.fedoraproject.org/updates/FEDORA-2018-2c0cea181a

Comment 17 Fedora Update System 2018-10-27 15:35:41 UTC
python-libNeuroML-0.2.45-4.fc28 has been pushed to the Fedora 28 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2018-f4c25f1515

Comment 18 Fedora Update System 2018-10-28 08:26:32 UTC
python-libNeuroML-0.2.45-5.fc28 has been submitted as an update to Fedora 28. https://bodhi.fedoraproject.org/updates/FEDORA-2018-f4c25f1515

Comment 19 Fedora Update System 2018-10-28 08:27:55 UTC
python-libNeuroML-0.2.45-5.fc27 has been submitted as an update to Fedora 27. https://bodhi.fedoraproject.org/updates/FEDORA-2018-9d4ad4de74

Comment 20 Fedora Update System 2018-10-28 18:47:20 UTC
python-libNeuroML-0.2.45-5.fc27 has been pushed to the Fedora 27 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2018-9d4ad4de74

Comment 21 Fedora Update System 2018-10-28 18:54:34 UTC
python-libNeuroML-0.2.45-5.fc28 has been pushed to the Fedora 28 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2018-f4c25f1515

Comment 22 Fedora Update System 2018-10-31 18:50:07 UTC
python-libNeuroML-0.2.45-5.fc29 has been pushed to the Fedora 29 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2018-2c0cea181a

Comment 23 Fedora Update System 2018-11-07 02:04:37 UTC
python-libNeuroML-0.2.45-5.fc28 has been pushed to the Fedora 28 stable repository. If problems still persist, please make note of it in this bug report.

Comment 24 Fedora Update System 2018-11-07 06:19:13 UTC
python-libNeuroML-0.2.45-5.fc27 has been pushed to the Fedora 27 stable repository. If problems still persist, please make note of it in this bug report.

Comment 25 Fedora Update System 2018-11-10 03:17:28 UTC
python-libNeuroML-0.2.45-5.fc29 has been pushed to the Fedora 29 stable repository. If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.